$KCODE = 'e'

require 'eb'
require 'cgi'
load 'config.rb'

LetMeSee_VERSION = '0.1.1'

# for HTML output
class String
  def html_output
    CGI.escapeHTML( self ).gsub(/\n/, '<br>')
  end
end

# let me see...
class LetMeSee
  attr_reader :dictlist, :dict, :query, :type, :maxhit
  attr_reader :bookname, :bookpath, :bookdir

  def LetMeSee::version
    LetMeSee_VERSION
  end

  def version
    LetMeSee::version
  end

  def initialize
    @cgi = CGI::new
    @query = @cgi['query'][0] || ''
    @dict = @cgi['dict']
    @type = @cgi['type'][0]
    @maxhit = @cgi['maxhit'][0].to_i
    @dictlist = $dictlist	# described in 'config.rb' file.
    @bookname = []		# eg. ''
    @bookpath = []		# eg. '/mnt/cdrom'
    @bookdir = []		# eg. 'koujien'
    @dictlist.each do |dictlist|
      b=EB::Book.new
      b.bind(dictlist)
      0.upto(b.subbook_count-1) do |i|
	@bookname.push(b.title(i))
	@bookpath.push(dictlist)
	@bookdir.push(b.directory(i))
      end
    end
  end

  def search (bookpath, bookdir)
    b=EB::Book.new
    b.bind(bookpath)
    0.upto(b.subbook_count-1) do |i|
      if (b.directory(i) == bookdir) then
	b.set(i)
	items = b.send(type, query, maxhit ).uniq
	return items
      end
    end
  end
end
